//
//  Pokemon.swift
//  Swiftement Pokemon
//
//  Created by Onoulade on 15/01/2022.
//

import Foundation

/*
 La classe Pokemon qui sera l'objet pour chaque... eh ben pokémon !
 */

class Pokemon {
    
    var nom: String
    
    var ptsVie: Float
    var maxVie: Float
    var ptsDefense: Int
    var vivant: Bool {
        get {
            return ptsVie > 0
        }
    }
    
    var capacites: [Capacite]
    var element: Element
    
    // Chaque pokémon est obligé d'avoir un élément
    init(nom: String, ptsVie: Float, ptsDefense: Int = 0, capacites: [Capacite], element: Element) {
        self.nom = nom
        self.ptsVie = ptsVie
        self.maxVie = ptsVie
        self.ptsDefense = ptsDefense
        self.capacites = capacites
        self.element = element
    }
    
    // Méthode appellée lorsque qu'un pokémon est soigné
    func gagne(pointsVie: Int) {
        self.ptsVie += Float(pointsVie)
        // On s'assure silplement qu'il ne puisse pas avoir un total de points de vie plus élevé que son maximum
        if self.ptsVie > self.maxVie {
            self.ptsVie = self.maxVie
        }
        let vieString = "(" + String(ptsVie) + ")"
        print(nom, " regagne ", pointsVie, " points de vie", vieString)
    }
    
    // Lorsqu'un pokemon perds des points de défense
    func subit(pointsDefense: Int) {
        self.ptsDefense -= pointsDefense
        // Là aussi on s'assure qu'il ne puisse pas avoir de défense négative
        if self.ptsDefense < 0 {
            self.ptsDefense = 0
        }
        print(nom, " voit sa défense affaiblie")
    }
    
    // Méthode appelée lorsqu'un pokémon subit des dégats
    func subit(pointsDegats: Float) {
        let totalDegats = (pointsDegats - Float(self.ptsDefense))
        self.ptsVie -= totalDegats
        let vieString = "(" + String(ptsVie) + ")"
        print(nom, " subit ", totalDegats, " points de dégâts", vieString)
        // Si il n'a plus de points de vie, on imprime qu'il est étourdit mais c'est la classe
        // Joueur qui s'occupera de vérifier si il est toujours en vie lorsqu'elle en aura besoin
        if self.ptsVie <= 0 {
            print(nom, " est étourdit...")
            self.ptsVie = 0
        }
        
    }
    
}
